#ifndef __VIDEOCONTROLSDLG_H__
#define __VIDEOCONTROLSDLG_H__

#include "ui_VideoControlsDialog.h"

class VideoControlsDlg : public QDialog, public Ui::VideoControlsDialog
{
Q_OBJECT
public:
	VideoControlsDlg( QWidget * parent = 0, Qt::WFlags f = 0 );
	 void Activate(void);

signals:
 
private:	
	int InitControl(int nType,QSlider *pSlider,QLineEdit *pEdit,QAbstractButton *pAuto=0,QAbstractButton *pOnePush=0);
	int SetControlToDefault(int nType,QSlider *pSlider,QLineEdit *pEdit,QAbstractButton *pAuto=0);
	void ShowGammaDouble(unsigned int nGamma);
	void ShowExposureMsec(void);
	int InitMField(void);
	int InitShutter(void);	
	int InitDefectCor(void);	
	int InitInvertPixel(void);
	int SetComboControlsToDefault(int nType);	

	bool bInit;
	
private slots:
	void DefaultSlot(void);
	void sliderExpSlot(void);
	void sliderExpTargetSlot(void);
	void sliderPllSlot(void);
	void sliderGainSlot(void);
	void sliderBlackLevelSlot(void);
	void AutoExposureSlot(void);
	void AutoBlacklevelSlot(void);
	void sliderBrightnessSlot(void);
	void sliderConrastSlot(void);
	void sliderGammaSlot(void);
	void sliderRedSlot(void);
	void sliderGreenSlot(void);
	void sliderBlueSlot(void);
	void WbSlot(void);
	void MFieldSlot(int nMFieldIndex);
	void ShutterSlot(int nShutterIndex);
	void DefPixelCorSlot(void);
	void InvertPixelSlot(void);

};

#endif // __VIDEOCONTROLSDLG_H__
