#ifndef GLWIDGET_H
#define GLWIDGET_H

#include <QGLWidget>
#include <QtOpenGL>
#include "ICubeDefines.h"


#ifndef GL_BGR_EXT
#define GL_BGR_EXT 0x80e0
#endif

#ifndef GL_BGRA_EXT
#define GL_BGRA_EXT 0x80e1
#endif


//------------------------------------------------------------------------
// Framing Window
//
class GLWidget;

class glWindow : public QWidget
{
    Q_OBJECT

public:
	glWindow();
    //glWindow(QWidget *parent /*= 0*/);
	void updateWindow(unsigned char* pBuf);
	void Activate(int nWidth,int nHeight,int nCallback);
	
private:
    GLWidget *glWidget;
    
protected:
	void closeEvent(QCloseEvent *event);    
	
};
//------------------------------------------------------------------------
// GL Widget
//
class GLWidget : public QGLWidget
{
    Q_OBJECT

public:
    GLWidget(QWidget *parent = 0);
    ~GLWidget();

    QSize minimumSizeHint() const;
    QSize sizeHint() const;
	
	void initializeGL();
 	void resizeGL(int width, int height);
 	      
	bool setImage(unsigned char* imgP);

	// image parameters
	unsigned int m_width, m_height, m_pixeldepth;
 
signals:
	
protected:
  
    void paintGL();

	void drawTexture(float ul, float ur, float ll, float lr);
	//void resetBox() { m_exit.setX(0); m_exit.setY(0); m_entry.setX(0); m_entry.setY(0);}

	// helper method
	unsigned int NextLargerPowerOfTwo(unsigned int n);  
  
private:
	
	// pointer to the data of the displayed image
	unsigned char* m_imgP;
	// width of the texture buffer
	unsigned int m_texWidth;
	// height of the texture buffer
	unsigned int m_texHeight;
	// texture identifier
	unsigned int m_texNameGL;
	// clipping rectangle for texture
	float m_texUpperLeftX, m_texUpperLeftY, m_texLowerRightX, m_texLowerRightY;
	// box parameters (for mouse dragging)
	QPoint m_entry, m_exit;	
	
};

#endif
